/* -------------------------------------------------------------------------------------------------

	GREMOTE DDEML-Client fr GALEP3

	1997 von Michael Thomas fr CONITEC Datensysteme

------------------------------------------------------------------------------------------------- */


#define LOGFILE	"Gremote.Log"

#include <windows.h>
#include <shellapi.h>
#include <ddeml.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <dir.h>

#include "glp_dde.h"




// Funktionsprototypen
//

long     FAR PASCAL _export WndProc     (HWND, UINT, UINT,  LONG) ;
HDDEDATA FAR PASCAL _export DdeCallback (UINT, UINT, HCONV, HSZ, HSZ, HDDEDATA, DWORD, DWORD) ;


// Selbstgemachte MessageIDs
//

typedef enum
{
	WM_USER_INITIATE = WM_USER+1,
	WM_USER_COMMAND,
	WM_USER_LOSGEHTS,
	WM_USER_FINISH

};


// Diverse Stringvariablen
//

char szAppName [] = "GALEP3 Client" ;
char szGSLFileName[MAXPATH];



// Ein Flag zur Synchronisierung
//

int DdeBusy = FALSE;


DWORD idInst;	// Kennung fr die Kommunikation mit DDEML
HCONV hConv ;  	// Kennung fr den Nachrichtenkanal zum Server
HWND  hwnd ;

FILE *hLogfile;



/* -------------------------------------------------------------------------------------------------

	Das bei Windowsprogrammen unvermeidliche WinMain ...

------------------------------------------------------------------------------------------------- */


int PASCAL WinMain (HANDLE hInstance, HANDLE hPrevInstance, LPSTR /*lpszCmdLine*/, int nCmdShow)
{
	MSG      msg ;
	FARPROC  pfnDdeCallback ;
	WNDCLASS wndclass ;

	if (!hPrevInstance)
	{
		wndclass.style         = CS_HREDRAW | CS_VREDRAW ;
		wndclass.lpfnWndProc   = WndProc ;
		wndclass.cbClsExtra    = 0 ;
		wndclass.cbWndExtra    = 0 ;
		wndclass.hInstance     = hInstance ;
		wndclass.hIcon         = LoadIcon (hInstance, szAppName) ;
		wndclass.hCursor       = LoadCursor (NULL, IDC_ARROW) ;
		wndclass.hbrBackground = GetStockObject (WHITE_BRUSH) ;
		wndclass.lpszMenuName  = NULL ;
		wndclass.lpszClassName = szAppName ;

		RegisterClass (&wndclass) ;
	}

	hwnd = CreateWindow (szAppName, "GRemote - DDE-Client fr GALEP 3",
	WS_OVERLAPPEDWINDOW,
	CW_USEDEFAULT, CW_USEDEFAULT,
	CW_USEDEFAULT, CW_USEDEFAULT,
	NULL, NULL, hInstance, NULL) ;


	// In dieser Datei werden alle Nachrichten von dem Server gespeichert damit der Fensterinhalt
	// restauriert werden kann
	// Die Datei mu an dieser Stelle geffnet werden, da durch UpdateWindow auf diese Datei zu
	// gegriffen wird
	//

	hLogfile = fopen (LOGFILE, "w+" );


	ShowWindow (hwnd, nCmdShow) ;
	UpdateWindow (hwnd) ;


	// Anmelden der Callback-Funktion "DdeCallback" beim DDE-Service.
	// Zuvor wird aber der Prologcode erzeugt (MakeProcInstance)
	//

	pfnDdeCallback = MakeProcInstance ((FARPROC) DdeCallback, hInstance) ;

	if (DdeInitialize (&idInst, (PFNCALLBACK) pfnDdeCallback, APPCLASS_STANDARD | APPCMD_CLIENTONLY, 0L))
	{
		MessageBox (hwnd, "Probleme beim Start des Client!",
		szAppName, MB_ICONEXCLAMATION | MB_OK) ;

		DestroyWindow (hwnd) ;
		return FALSE ;
	}

	// In dieser Datei werden alle Nachrichten von dem Server gespeichert damit der Fensterinhalt
	// restauriert werden kann
	//

	hLogfile = fopen (LOGFILE, "w+" );


	// ... und ab die Post
	//

	SendMessage (hwnd, WM_USER_INITIATE, 0, 0L) ;


	while (GetMessage (&msg, NULL, 0, 0))
	{
		TranslateMessage (&msg) ;
		DispatchMessage (&msg) ;
	}

	// Abmelden bei DDEML
	//

	DdeUninitialize (idInst) ;

	fclose (hLogfile);
	return msg.wParam ;
}




/* -------------------------------------------------------------------------------------------------

	Die Callback-Funktion

------------------------------------------------------------------------------------------------- */

HDDEDATA FAR PASCAL _export DdeCallback (UINT iType, UINT iFmt, HCONV /*hConv*/, HSZ /* hsz1 */, HSZ hsz2,
											HDDEDATA hData, DWORD /*dwData1*/, DWORD /*dwData2*/)
{
	char szItem [100], IncomingMessages[128];

	switch (iType)
	{
		// DdePostAdvice-Aufruf durch den SERVER hat diese Nachricht zur Folge
		//
		case XTYP_ADVDATA:
		{
			// hsz1  = Thema // hsz2  = Datum // hData = die Daten

			// Prfung auf passendes Format und Datum

			if (iFmt != CF_TEXT)
			return DDE_FNOTPROCESSED ;

			DdeQueryString (idInst, hsz2, szItem, sizeof (szItem), 0) ;

			// Vergleiche das Thema der eingehenden Nachricht mit dem eigenen, bekannten
			// Theme

			if (strcmp (szGSLFileName, szItem) != 0)
				return DDE_FNOTPROCESSED ;

			// Daten beim Betriebssystem abholen
			//
			DdeGetData (hData, IncomingMessages, sizeof (IncomingMessages), 0) ;

			// GSL-Skript beendet?
			//

			if (strcmp(IncomingMessages, GSL_FINISH) == NULL)
			{
				// hier jezt die Heie Verbindung lsen (und damit freigeben fr evtl. nchsten
				// Versuch mit gleicher GSL-Datei
				//
				HSZ hszItem = DdeCreateStringHandle (idInst, szGSLFileName, 0) ;
				DdeClientTransaction (NULL, 0, hConv, hszItem, CF_TEXT, XTYP_ADVSTOP, TIMEOUT_ASYNC, NULL) ;
				DdeFreeStringHandle (idInst, hszItem) ;

				DdeBusy = FALSE;
				PostMessage (hwnd, WM_USER_FINISH, 0, 0l);
			}

			// Daten speichern und fr Aktualisierung
			// des Fensters sorgen

			// Empfangene Message am Dateiende
			//
			fseek (hLogfile, 0, SEEK_END);

			strcat (IncomingMessages, "\n");
			fwrite (IncomingMessages, strlen(IncomingMessages), sizeof (char), hLogfile);

			InvalidateRect (hwnd, NULL, FALSE) ;

			return DDE_FACK ;
		}

		case XTYP_DISCONNECT:
		{
			MessageBox (hwnd, "Abbruch durch den Server.", szAppName, MB_ICONASTERISK | MB_OK) ;

			hConv = NULL ;
		}
	}

	return NULL ;
}





/* -------------------------------------------------------------------------------------------------

	WndProc - Kmmert sich um den Windows-Teil des Programms

------------------------------------------------------------------------------------------------- */

long FAR PASCAL _export WndProc (HWND hwnd, UINT message, UINT wParam, LONG lParam)
{
	// Das Galep3 Programmverzeichnis sollte aus der Datei Galep3.Ini im Windows-Verzeichnis aus-
	// gelesen werden.
	// Um das Beispiel nicht zu berfrachten begnge ich mich hier mit einer Stringkonstanten
	//

// 	char * szAppDir = "../workdir";
	char * szAppDir = "/galep3";
	char * szAppName = "galep3.exe";
	char * szAppArgs = " -dde";

	static char CommandLine[128];

	static char szService [] = DDE_SERVICE;			// def in glp_dde.h
	static char szTopic[] = DDE_TOPIC_EXECGSL;      // ``
	static short cxChar, cyChar ;
	char         szBuffer [128], ch;
	int nBuffer;
	HDC          hdc ;
	HSZ          hszService, hszTopic, hszItem ;
	PAINTSTRUCT  ps ;
	short        i = 0, x = 0, y = 0 ;
	TEXTMETRIC   tm ;

	switch (message)
	{
		case WM_CREATE:
		{
			hdc = GetDC (hwnd) ;
			GetTextMetrics (hdc, &tm) ;
			cxChar = tm.tmAveCharWidth ;
			cyChar = tm.tmHeight + tm.tmExternalLeading ;
			ReleaseDC (hwnd, hdc) ;

			DragAcceptFiles (hwnd, TRUE);

			return 0 ;
		}

		case WM_DROPFILES:
		{
			DragQueryFile ((HANDLE)wParam, 0, szGSLFileName, sizeof(szGSLFileName)-1);
			strlwr(szGSLFileName);

			PostMessage (hwnd, WM_USER_LOSGEHTS, 0, 0l);
			return 0;
		}

		// Auswertung der selbstdefinierten Message "WM_USER_INITIATE"
		//
		case WM_USER_INITIATE:
		{
			strcpy (CommandLine, szAppDir);
			strcat (CommandLine, "/");
			strcat (CommandLine, szAppName);
			strcat (CommandLine, szAppArgs);

			// 1. Verbindungsversuch
			//
			// ber DdeConnect wird eine "Einfachverbindung" hergestellt.
			// die Alternativfunktion DdeConnectList ist fr diese Anwendung nicht erforderlich

			hszService = DdeCreateStringHandle (idInst, szService, 0);	// gesuchter Server
			hszTopic   = DdeCreateStringHandle (idInst, szTopic, 0) ;      	// Thema

			hConv = DdeConnect (idInst, hszService, hszTopic, NULL) ;

			// War nichts? -> Server starten

			if (hConv == NULL)
			{
				WinExec (CommandLine, SW_SHOWNORMAL) ;

				// 2. Verbindungsversuch

				hConv = DdeConnect (idInst, hszService, hszTopic, NULL) ;
			}

			// String-Handles freigeben
			//
			DdeFreeStringHandle (idInst, hszService) ;
			DdeFreeStringHandle (idInst, hszTopic) ;


			// Falls sicht der Server auch beim zweiten Versuch nicht gemeldet hat wird eine
			// Fehlermeldung ausgegeben
			//
			if (!hConv)
			{
				MessageBox (hwnd, "Keine Verbindung mit Galep3.exe!",
				szAppName, MB_ICONEXCLAMATION | MB_OK) ;
			}

			return (0);
		}


		// Hier wird eine Anfragen an den Server geschickt. Die Frage lautet: GSL-Dateiname?
		// Fr alle Antworten zu dieser Frage mu der Server diese Frage (also den GSL-Dateinamen)
		// als "Item" verwenden
		//
		case WM_USER_LOSGEHTS:
		{
			DragAcceptFiles (hwnd, FALSE);	// Ab jetzt keine Dateien mehr annehmen

			// Bei Drag'n'Drop ist das Falsche Fenster aktiv
			// Dieses Fenster mu aktiviert werden!
			//
			SetActiveWindow(hwnd);

			if (hConv)
			{
				hszItem = DdeCreateStringHandle (idInst, szGSLFileName, 0);
				DdeClientTransaction (NULL, 0, hConv, hszItem, CF_TEXT, XTYP_ADVSTART | XTYPF_ACKREQ, TIMEOUT_ASYNC, NULL) ;
				DdeFreeStringHandle (idInst, hszItem) ;
				DdeBusy = TRUE;
			}
			return (0);
		}

		// Das Skript wurde beendet
		//
		case WM_USER_FINISH:
		{
			DragAcceptFiles (hwnd, TRUE);	// jetzt wieder Dateien annehmen
			return (0);
		}



		case WM_PAINT:
		{
			hdc = BeginPaint (hwnd, &ps) ;

			fseek (hLogfile, 0, SEEK_SET);
			nBuffer = 0;
			i=0;

			while ((ch = fgetc(hLogfile)) != EOF)
			{
				if (ch != '\n')
				{
					if (nBuffer < sizeof(szBuffer)-1)
						szBuffer[nBuffer++] = ch;
				}
				else
				{
					szBuffer[nBuffer]=0;	// String terminieren
					x = cxChar ;
					y = i  * cyChar ;
					TextOut (hdc, x, y, szBuffer, strlen(szBuffer)) ;
					i++;
					nBuffer = 0;
				}
			}
			EndPaint (hwnd, &ps) ;
			return 0 ;
		}


		// Die Taste 'ESC' dient zum Lschen des Puffers
		// (solange keine bessere Mglichkeit gefunden ist)
		//
		case WM_KEYDOWN:
		{
			if (wParam == 0x1b)
			{
				fclose (hLogfile);
				hLogfile = fopen (LOGFILE, "w+" );

				InvalidateRect(hwnd, NULL, TRUE);
				PostMessage(hwnd, WM_PAINT, 0, 0l);
			}

			break;
		}





		// Falls eine Verbindung besteht, und noch ein Anfrage offen ist mu nun die heie
		// Verbindung zum Datensatzt gelst werden.
		// Danach wird Verbindung mit dem Server beendet.
		//
		case WM_CLOSE:
		{
			if (hConv != NULL)
			{
				// 1. Verbindung zum Datensatz lsen
				//
				if (DdeBusy)
				{
					hszItem = DdeCreateStringHandle (idInst, szGSLFileName, 0) ;
					DdeClientTransaction (NULL, 0, hConv, hszItem, CF_TEXT, XTYP_ADVSTOP, DDE_TIMEOUT, NULL) ;
					DdeFreeStringHandle (idInst, hszItem) ;
				}

				// 2. Verbindung zum Server beenden
				//
				DdeDisconnect (hConv) ;
			}
			break ;             // <- weiter mit DefWindowProc
		}

		case WM_DESTROY:
			PostQuitMessage (0) ;
			return 0 ;
	}
	return DefWindowProc (hwnd, message, wParam, lParam) ;
}

